#include <AI8051U.H>

/**
  * @brief  RTC初始化
  * @param  无
  * @retval 无
  */
void RTC_Init(void)	//配置RTC
{
//选择内部32K
	/*
	IRC32KCR = 0X80;			//启用内部低速IRC振荡器
	while(!(IRC32KCR & 0x01));	//等待时钟稳定
	RTCCFG |= 0x02;				//选择内部低速IRC作为RTC时钟源
	*/

//选择外部32K
	X32KCR = 0xC0;				//启用外部32K晶振
	while(!(X32KCR & 0x01));	//等待时钟稳定
	RTCCFG &= ~0x02;			//选择外部32K作为RTC时钟源
	
	INIYEAR = 23;				//Y:2023
	INIMONTH = 12;				//M:12
	INIDAY = 31;				//D:31
	INIHOUR = 23;				//H:23
	INIMIN = 59;				//M:59
	INISEC = 50;				//S:50
	
	INISSEC = 0;				//S/128:0
	
	RTCIF = 0;					//清中断标志
	RTCIEN = 0x08;				//使能RTC秒中断
	RTCCR = 0x01;				//RTC使能
	RTCCFG |= 0x01;				//触发RTC寄存器初始化
	while(RTCCFG & 0x01);		//等待完成初始化
}

/*
void RTC_Isr() interrupt 13		//因为中断号大于31，所以用13号（lsr.a51文件）
{
	if(RTCIF & 0x08)			//判断是否秒中断
	{
		RTCIF &= ~0x08;			//清中断标志
		
	}
}
*/

/*lsr.a51
CSEG	AT	0123H
LJMP	006BH

END
*/


