#include <AI8051U.H>
#include "intrins.h"
#include "stdio.h"

#define        MAIN_Fosc               24000000L
#define        Baudrate                9600L
#define        TM                                (65536-(MAIN_Fosc/Baudrate+2)/4)

bit                B1S_Flag;
void RTC_config(void);

void UartInit(void)
{
	SCON = 0x50;		//8位数据,可变波特率
	AUXR |= 0x01;		//串口1选择定时器2为波特率发生器
	AUXR |= 0x04;		//定时器时钟1T模式
	TL2 = TM;			//设置定时初始值
	TH2 = TM >> 8;			//设置定时初始值
	AUXR |= 0x10;		//定时器2开始计时
}

void UartPutc(unsigned char dat)
{
        SBUF = dat;
        while(TI == 0);
        TI = 0;
}

char putchar(char c)
{
        UartPutc(c);
        return c;
}

void RTC_Isr() interrupt 13
{
        if(RTCIF & 0x08)
        {
                RTCIF &= ~0x08;
                B1S_Flag = 1;
        }
}
void Delay100ms(void)	//@24.000MHz
{
	unsigned char data i, j, k;

	_nop_();
	_nop_();
	i = 13;
	j = 45;
	k = 214;
	do
	{
		do
		{
			while (--k);
		} while (--j);
	} while (--i);
}


void main(void)
{
        P_SW2 = 0x80;                //使能XFR，没有冲突不用关闭
        CKCON = 0x00;                //设置外部数据总线速度为最快
        WTST = 0x00;                //设置程序代码等待参数
                                    //赋值为0可将CPU执行程序的速度设置为最快
        P0M1 = 0x00;        P0M0 = 0x00;//配置P0口为准双向口
        P1M1 = 0x00;        P1M0 = 0x00;//配置P1口为准双向口
        P2M1 = 0x00;        P2M0 = 0x00;//配置P2口为准双向口
        P3M1 = 0x00;        P3M0 = 0x00;//配置P3口为准双向口
        P4M1 = 0x00;        P4M0 = 0x00;//配置P4口为准双向口
        P5M1 = 0x00;        P5M0 = 0x00;//配置P5口为准双向口
        
        UartInit();
        RTC_config();
        EA = 1;
		Delay100ms();
		Delay100ms();
		Delay100ms();
        printf("RTC Test Programme!\r\n");
        
        while(1)
        {
                if(B1S_Flag)
                {
                        B1S_Flag = 0;
                        printf("Year=20%bd ",YEAR);
                        printf("Month=%bd ",MONTH);
                        printf("Day=%bd ",DAY);
                        printf("Hour=%bd ",HOUR);
                        printf("Minute=%bd ",MIN);
                        printf("Second=%bd ",SEC);
                        printf("\r\n");
                }
        }
}

void RTC_config(void)
{
		//选择外部 32K
//        X32KCR = 0xC0;
//        while(!(X32KCR & 0x01));
//        RTCCFG &= ~0x02;
	
		//选择内部低速 IRC
		IRC32KCR = 0x80;
		while (!(IRC32KCR & 0x01));
		RTCCFG |= 0x02;
  
        INIYEAR = 21;
        INIMONTH = 12;
        INIDAY = 31;
        INIHOUR = 23;
        INIMIN = 59;
        INISEC = 50;
        
        INISSEC = 0;
        
        RTCIF = 0;
        RTCIEN = 0X08;
        RTCCR = 0X01;
        RTCCFG |= 0X01;
        while(RTCCFG & 0x01);
}
